#!/bin/sh

MULTIPATH_CONF="/etc/multipath.conf"

DISTRO="";
OS="";
PRODUCT="";
PACKAGE="";
VERSION="";

UPDATE_MANAGER_EXE="";
UPDATE_MANAGER_ARG="";

FEDORA_ETC_RELEASE_FILE="/etc/redhat-release";

REDHAT_ETC_RELEASE_FILE="/etc/redhat-release";

SUSE_ETC_RELEASE_FILE="/etc/SuSE-release";

# DISTRO_LOCAL_RPMS_DIR="Distro/RPMS";
# DISTRO_DEP_PACKAGE_VERS="bun-1.3.6 cor-0.23.6-12.0";
# DISTRO_PACKAGES="foo1();foo2(bar2 baz2);";
# DISTRO_RPM_EXE="/bin/rpm";
# DISTRO_UPDATE_MANAGER_EXE="/usr/bin/yum";
# DISTRO_UPDATE_MANAGER_ARG="install";


### Post_Install sub section

Post_Install()
{

	# Check for sucessful install

	# Perform post install for dm or md
	post_install_dm

}

post_install_dm()
{
	dm_patch_multipath_conf
	
	### FIXME
	#Choose RedHat or SuSE
	#RedHat_dm_enable_daemon
}

dm_patch_multipath_conf()
{

	### FIXME Dev Inq Strings should be in a seperate OEM-conf'g'able file, parsed and read in.

	# Add device profiles
	dm_patch_multipath_conf_devices 1 "XYRATEX " "F5200E          " || return 1;
	dm_patch_multipath_conf_devices 1 "XYRATEX " "F5402E          " || return 1;
	dm_patch_multipath_conf_devices 1 "XYRATEX " "F5403E          " || return 1;
	dm_patch_multipath_conf_devices 1 "XYRATEX " "F5404E          " || return 1;
	dm_patch_multipath_conf_devices 1 "XYRATEX " "E5402E          " || return 1;	
	

	retval=1;
	for (( ; $retval != 0 ; )); do
		dm_patch_multipath_conf_devnode_blacklist;
		retval=$?;
	done;
	echo "$MULTIPATH_CONF patched to use default values for devnode_blacklist section";

}

dm_patch_multipath_conf_devnode_blacklist()
{

PATCH_HEADER="--- $MULTIPATH_CONF-orig 2006-01-01 00:00:00.000000000 -0000
+++ $MULTIPATH_CONF 2006-01-01 00:01:00.000000000 -0000"

### FIXME Probable... put in a blacklist in lieu of the default?

	if [ -e  $MULTIPATH_CONF ]; then
		if [ ! -w $MULTIPATH_CONF ]; then echo "Cannot write to $MULTIPATH_CONF; be sure you're running as root"; echo; exit 1; fi;
		
		SECTION="devnode_blacklist"
		egrep "^$SECTION" $MULTIPATH_CONF > /dev/null; dirtyConf=$?;
		[ $dirtyConf == 0 ] || return 0;
		

		# Comment out any existing devnode_blacklist
		let STARTLINE=`egrep -n "^$SECTION" $MULTIPATH_CONF | awk -F : '{print $1}'`;
		let NUMLINES=` awk -F "\n" -v line=$STARTLINE 'NR >= line' $MULTIPATH_CONF | \
				egrep \} -n | awk -F : 'NR == 1 {print $1}'`-1;
		let OPENS=`egrep -A $NUMLINES "^$SECTION" $MULTIPATH_CONF \
			| awk -v lines=$NUMLINES 'NR <= lines+1'| egrep -o "\{" \
			| uniq -c | grep \{ | awk '{print $1}'`;
		let CLOSE=`egrep -A $NUMLINES "^$SECTION" $MULTIPATH_CONF \
			| awk -v lines=$NUMLINES 'NR <= lines+1'| egrep -o "\}" \
			| uniq -c | grep \} | awk '{print $1}'`;		
		let NUMLINES++

		for (( ; $OPENS > $CLOSE ; NUMLINES++ )); do
			let ENDLINE=$STARTLINE+$NUMLINES-1
			let OPENS=`egrep -A $NUMLINES "^$SECTION" $MULTIPATH_CONF \
				| awk -v lines=$NUMLINES 'NR <= lines+1'| egrep -o "\{" \
				| uniq -c | grep \{ | awk '{print $1}'`;
			let CLOSE=`egrep -A $NUMLINES "^$SECTION" $MULTIPATH_CONF \
				| awk -v lines=$NUMLINES 'NR <= lines+1'| egrep -o "\}" \
				| uniq -c | grep \} | awk '{print $1}'`;
		done;

		let ENDLINE=$STARTLINE+$NUMLINES-1
		let NUMLINEPLUS=$NUMLINES+1
		PATCH=`echo "$PATCH_HEADER"; echo "@@ -$STARTLINE,$NUMLINES +$STARTLINE,$NUMLINEPLUS @@"`;
		PATCH=$PATCH`echo; echo "+### Patched by svpm installer - Following $NUMLINES lines commented out ($DATE)"; \
					awk -v start=$STARTLINE -v end=$ENDLINE -F : 'NR >= start && NR <= end {print "-"$0 "\n+#"$0}' $MULTIPATH_CONF`;
		tmpIFS=$IFS; IFS="";
		#echo $PATCH
		echo $PATCH | patch $MULTIPATH_CONF > /dev/null;
		IFS=$tmpIFS;
	fi
	
	egrep "^$SECTION" $MULTIPATH_CONF > /dev/null; retval=$?;
	if [ $retval == 0 ]; then return 1; else return 0; fi
}

dm_patch_multipath_conf_devices()
{

PATCH_HEADER="--- $MULTIPATH_CONF-orig 2006-01-01 00:00:00.000000000 -0000
+++ $MULTIPATH_CONF 2006-01-01 00:01:00.000000000 -0000"

	DEVICE_PROFILE_SELECT=$1;
	VENDOR=$2;
	PRODUCT=$3;
	
	DEVICE_PROFILE_1="	device {
		vendor			\"$VENDOR\"
		product			\"$PRODUCT\"
		path_grouping_policy	failover
		path_checker		readsector0
		path_selector		\"round-robin 0\"
		features		\"1 queue_if_no_path\"
		hardware_handler	\"0\"
		failback		1
		no_path_retry		queue
	}"

	DEVICE=$DEVICE_PROFILE_1
	if [ $DEVICE_PROFILE_SELECT == 1 ]; then DEVICE=$DEVICE_PROFILE_1; fi

	if [ ! -e  $MULTIPATH_CONF ]; then
		dir=`dirname $MULTIPATH_CONF`;
		if [ ! -d $dir ]; then echo "$dir does not exist; cannot patch $MULTIPATH_CONF"; echo; return 1; fi;
		if [ ! -w $dir ]; then echo "Cannot write to $dir"; echo; return 1; fi
		echo "Creating new file: $MULTIPATH_CONF";
		echo "devices {" >> $MULTIPATH_CONF;
		echo "$DEVICE" >> $MULTIPATH_CONF;
		echo "}" >> $MULTIPATH_CONF;
		echo "$MULTIPATH_CONF patched for storage of type: $VENDOR $PRODUCT";
	else
		if [ ! -w $MULTIPATH_CONF ]; then echo "Cannot write to $MULTIPATH_CONF; be sure you're running as root"; echo; return 1; fi;

		# Patch "devices" section
		if egrep -q "\"$VENDOR\"" $MULTIPATH_CONF && egrep -q "\"$PRODUCT\"" $MULTIPATH_CONF; then
			echo "$MULTIPATH_CONF patched for storage of type: $VENDOR $PRODUCT";
		else
			egrep devices $MULTIPATH_CONF | egrep -qv "#"; dirtyConf=$?;
			tmpIFS=$IFS; IFS="";
			if [ $dirtyConf == 1 ]; then
				#echo "Clean $MULTIPATH_CONF found";
				let LINENUM=`cat $MULTIPATH_CONF | wc -l`+1;
				let DEVNUMLINES=`echo $DEVICE | wc -l`+3;
				PATCH=`echo $PATCH_HEADER; echo "@@ -$LINENUM,0 +$LINENUM,$DEVNUMLINES @@"`;
				PATCH=`echo $PATCH; echo "+devices {"; echo "+### Patched by svpm installer - Following device section added ($DATE)"`;
				PATCH=`echo $PATCH; echo $DEVICE | awk -F "\n" '{print "+"$1}'; echo "+}"`;
			else 
				#echo "Dirty $MULTIPATH_CONF found";
				let LINENUM=`egrep -n ^devices $MULTIPATH_CONF | awk -F : '{print $1}'`;
				let DEVNUMLINES=`echo $DEVICE | wc -l`+1;
				PATCH=`echo $PATCH_HEADER; echo "@@ -$LINENUM,0 +$LINENUM,$DEVNUMLINES @@"`;
				PATCH=`echo $PATCH; echo "+### Patched by svpm installer - Following device section added ($DATE)"`;
				PATCH=`echo $PATCH; echo $DEVICE | awk -F "\n" '{print "+"$1}'`;
			fi;
			#echo $PATCH;
			echo $PATCH | patch $MULTIPATH_CONF > /dev/null;
			echo "$MULTIPATH_CONF patched for storage of type: $VENDOR $PRODUCT";
			IFS=$tmpIFS;
		fi;
	fi;
	return 0
}

RedHat_dm_enable_daemon()
{
	echo;
	/sbin/chkconfig multipathd on
	/sbin/service multipathd start
}

#DOWHAT=$1
#echo $DOWHAT && exit 0;
#$DOWHAT || exit 1;
Post_Install && exit 0;
#echo
#echo "Problem with post install"
#echo
